* PROGRAM:  FIELDSIZ.PRG
* PURPOSE:  Find the smallest size a character field can be without
*           losing any current data
*
* REMARKS:  You can call this program either from the xbase language
*           or run from inside another program.
*
* COMMAND: DO FIELDSIZ with 'FILENAME' (dBASE or FoxBase/FoxPro)
*   OR     FIELDSIZE <filename> if compiled with CLIPPER

PARAMETERS Filename

CLEAR
SET TALK OFF
SET SCOREBOARD OFF
SET STATUS OFF
CLOSE DATABASES
SELECT 1
USE &Filename

? "File: "+filename+".DBF"
? "Optimum structure:"
?
msavtot=0
maux=1
DO WHILE LEN(FIELD(maux))>0
    IF TYPE(FIELD(maux))<>"C"
    maux=maux+1
    LOOP
    ENDIF
    mtotal=0
    mname=FIELD(maux)
    GOTO TOP
    DO WHILE .NOT. EOF()
        IF LEN(TRIM(&mname))>mtotal
            mtotal=LEN(TRIM(&mname))
        ENDIF
    SKIP
    ENDDO
    msaved=(LEN(&mname)-mtotal)*RECCOUNT()
    msavtot=msavtot+msaved
    msg=IIF(msaved>0," bytes to save"," no change on this field")
    ? RIGHT(SPACE(10)+TRIM(FIELD(maux)),11),mtotal,STR(msaved)+msg
    maux=maux+1
ENDDO
?
? "Total number of bytes that can be saved: = "+LTRIM(STR(msavtot))
CLOSE DATABASES
RETURN
